diff -ruN qmail-1.03-orig/auth_pop.c qmail-1.03-ldap-20060201-orig/auth_pop.c
--- qmail-1.03-orig/auth_pop.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auth_pop.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,240 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <errno.h>
+#include <unistd.h>
+#include "byte.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "pbsexec.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "readwrite.h"
+#include "sgetopt.h"
+#include "str.h"
+#include "stralloc.h"
+#include "substdio.h"
+#include "timeoutread.h"
+
+#include "auth_mod.h"
+
+#ifndef PORT_POP3 /* this is for testing purposes */
+#define PORT_POP3	110
+#endif
+
+const unsigned int auth_port = PORT_POP3;
+
+#define UP_LEN 513
+static char auth_up[UP_LEN];
+static int auth_argc;
+static char **auth_argv;
+
+void
+auth_init(int argc, char **argv, stralloc *login, stralloc *authdata)
+{
+	char		*l, *p;
+	unsigned int	uplen, u;
+	int		n, opt;
+
+	while ((opt = getopt(argc, argv, "d:")) != opteof) {
+		switch (opt) {
+		case 'd':
+			pbstool = optarg;
+			break;
+		default:
+			auth_error(AUTH_CONF);
+		}
+	}
+	argc -= optind;
+	argv += optind;
+
+	if (argc < 1)
+		auth_error(AUTH_CONF);
+	auth_argc = argc;
+	auth_argv = argv;
+	
+	for (uplen = 0;;) {
+		do {
+			n = subread(3, auth_up + uplen,
+			    sizeof(auth_up) - uplen);
+		} while (n == -1 && errno == EINTR);
+		if (n == -1)
+			auth_error(ERRNO);
+		if (n == 0) break;
+		uplen += n;
+		if (uplen >= sizeof(auth_up))
+			auth_error(PANIC);
+	}
+	close(3);
+	auth_up[uplen++] = '\0';
+	
+	u = 0;
+	l = auth_up;
+	while (auth_up[u++]) ;
+	if (u == uplen)
+		auth_error(NEEDED);
+	p = auth_up + u;
+	while (auth_up[u++]) ;
+	if (u == uplen)
+		auth_error(NEEDED);
+
+	if (!stralloc_copys(login, l))
+		auth_error(ERRNO);
+	if (!stralloc_0(login)) 
+		auth_error(ERRNO);
+
+	if (!stralloc_copys(authdata, p))
+		auth_error(ERRNO);
+	if (!stralloc_0(authdata))
+		auth_error(ERRNO);
+
+	/* up no longer needed so delete it */
+	byte_zero(auth_up, sizeof(auth_up));
+}
+
+void
+auth_fail(const char *login, int reason)
+{
+	/* in the qmail-pop3 chain it is not possible to have multiples 
+	 * authentication modules. So lets exit with the correct number ... */
+	/* In this case we can use auth_error() */
+	logit(2, "warning: auth_fail: user %s failed\n", login);
+	auth_error(reason);
+}
+
+void
+auth_success(const char *login)
+{
+	/* pop befor smtp */
+	pbsexec();
+	
+	/* start qmail-pop3d */
+	execvp(*auth_argv,auth_argv);
+
+	auth_error(AUTH_EXEC);
+	/* end */
+}
+
+void auth_error(int errnum)
+{
+	/*
+	 * See qmail-popup.c for exit codes meanings.
+	 */
+	logit(2, "warning: auth_error: authorization failed (%s)\n",
+		   qldap_err_str(errnum));
+
+	if (errnum == AUTH_CONF) _exit(1);
+	if (errnum == TIMEOUT || errnum == LDAP_BIND_UNREACH) _exit(2);
+	if (errnum == BADPASS || errnum == NOSUCH) _exit(3);
+	if (errnum == NEEDED || errnum == ILLVAL || errnum == BADVAL) _exit(25);
+	if (errnum == ACC_DISABLED) _exit(4);
+	if (errnum == BADCLUSTER) _exit(5);
+	if (errnum == MAILDIR_CORRUPT) _exit(6);
+	if (errnum == MAILDIR_FAILED) _exit(61);
+	if (errnum == MAILDIR_NONEXIST) _exit(62);
+	if (errnum == AUTH_EXEC) _exit(7);
+	if (errnum == ERRNO && errno == error_nomem) _exit(8);
+	_exit(111);
+}
+
+char *
+auth_aliasempty(void)
+{
+	if (auth_argc > 0)
+		return auth_argv[auth_argc-1];
+	return (char *)0;
+}
+
+#ifdef QLDAP_CLUSTER
+static void get_ok(int);
+
+static void get_ok(int fd)
+/* get the ok for the next command, wait for "+OK.*\r\n" */
+/* This should be a mostly correct solution (adapted from fetchmail) */
+{
+#define AUTH_TIMEOUT 10 /* 10 sec timeout */
+#define OK_LEN 512      /* max length of response (RFC1939) */
+	char ok[OK_LEN];
+	char *c;
+	int  len;
+	int  i;
+
+	/* first get one single line from the other pop server */
+	len = timeoutread(AUTH_TIMEOUT, fd, ok, OK_LEN);
+	if (len == -1) 
+		auth_error(ERRNO);
+	if (len != 0) {
+		c = ok;
+		if (*c == '+' || *c == '-')
+			c++;
+		else
+			auth_error(BADCLUSTER);
+		for (i = 1; i < len /* paranoia */ && 
+				('A' < *c && *c < 'Z') ; ) { i++; c++; }
+
+		if (i < len) {
+			*c = '\0';
+			if (str_diff(ok, "+OK") == 0)
+				return;
+			else if (str_diffn(ok, "-ERR", 4))
+				/* other server is not happy */
+				auth_error(BADCLUSTER);
+		}
+	}
+	/* ARRG, very strange POP3 answer */
+	auth_error(BADCLUSTER);
+}
+
+void auth_forward(int fd, char *login, char *passwd)
+{
+	char buf[512];
+	substdio ss;
+
+	substdio_fdbuf(&ss,subwrite,fd,buf,sizeof(buf));
+	get_ok(fd);
+	substdio_puts(&ss, "user "); 
+	substdio_puts(&ss, login);
+	substdio_puts(&ss, "\r\n");
+	substdio_flush(&ss);
+	get_ok(fd);
+	substdio_puts(&ss, "pass "); 
+	substdio_puts(&ss, passwd); 
+	substdio_puts(&ss, "\r\n");
+	substdio_flush(&ss);
+
+}
+
+#endif /* QLDAP_CLUSTER */
+
diff -ruN qmail-1.03-orig/auth_smtp.c qmail-1.03-ldap-20060201-orig/auth_smtp.c
--- qmail-1.03-orig/auth_smtp.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auth_smtp.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,213 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <errno.h>
+#include <unistd.h>
+#include "base64.h"
+#include "byte.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "getln.h"
+#include "output.h"
+#include "qldap.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "read-ctrl.h"
+#include "str.h"
+#include "stralloc.h"
+#include "subfd.h"
+#include "substdio.h"
+#include "timeoutread.h"
+
+#include "checkpassword.h"
+
+#include "auth_mod.h"
+
+checkfunc	cfuncs[] = {
+	check_ldap,
+	0
+};
+
+stralloc line = {0};
+stralloc plain = {0};
+
+void
+auth_init(int argc, char **argv, stralloc *login, stralloc *authdata)
+{
+	char *s, *smax;
+	int match;
+	
+	if (argc != 1)
+		auth_error(AUTH_CONF);
+	
+	if (getln(subfdin, &line, &match, '\0') != 0)
+		auth_error(ERRNO);
+	if (!match) auth_error(NEEDED);
+	if (!str_diff(line.s, "login")) {
+		if (getln(subfdin, &line, &match, '\0') != 0)
+			auth_error(ERRNO);
+		if (!match) auth_error(NEEDED);
+		if (b64_ptons(line.s, login) == -1) auth_error(BADVAL);
+		if (getln(subfdin, &line, &match, '\0') != 0)
+			auth_error(ERRNO);
+		if (!match) auth_error(NEEDED);
+		if (b64_ptons(line.s, authdata) == -1) auth_error(BADVAL);
+		/* XXX we should check if there is some bad
+		 * data in both values */
+		if (!stralloc_0(login)) auth_error(ERRNO);
+		if (!stralloc_0(authdata)) auth_error(ERRNO);
+		return;
+	}
+	if (!str_diff(line.s, "plain")) {
+		/*
+		 * plain sends: [authorize-id]\0authenticate-id\0password
+		 */
+		if (!stralloc_copys(login, "")) auth_error(ERRNO);
+		if (!stralloc_copys(authdata, "")) auth_error(ERRNO);
+		if (getln(subfdin, &line, &match, '\0') != 0)
+			auth_error(ERRNO);
+		if (!match) auth_error(NEEDED);
+		if (b64_ptons(line.s, &plain) == -1) auth_error(BADVAL);
+		s = plain.s; smax = s + plain.len;
+		while (*s++ != '\0') if (s >= smax) auth_error(BADVAL);
+		do {
+			if (!stralloc_append(login, s)) auth_error(ERRNO);
+			if (s >= smax) auth_error(BADVAL);
+		} while (*s++ != '\0');
+		while (*s && s < smax) {
+			if (!stralloc_append(authdata, s)) auth_error(ERRNO);
+			s++;
+		}
+		if (!stralloc_0(authdata)) auth_error(ERRNO);
+		return;
+	}
+	auth_error(AUTH_TYPE);
+}
+
+void
+auth_fail(const char *login, int reason)
+{
+	logit(2, "warning: auth_fail: user %s failed\n", login);
+
+	if (substdio_putflush(subfdout, "D", 1) == -1) auth_error(ERRNO);
+	_exit(0);
+}
+
+void
+auth_success(const char *login)
+{
+	if (substdio_put(subfdout, "K", 1) == -1) auth_error(ERRNO);
+	if (substdio_puts(subfdout, login) == -1) auth_error(ERRNO);
+	if (substdio_putflush(subfdout, "", 1) == -1) auth_error(ERRNO);
+	_exit(0);
+}
+
+void auth_error(int errnum)
+{
+	logit(2, "warning: auth_error: authorization failed (%s)\n",
+		   qldap_err_str(errnum));
+	if (errnum == BADVAL || errnum == NEEDED || errnum == ILLVAL) {
+		if (substdio_putflush(subfdout, "Z", 1) == -1)
+			auth_error(ERRNO);
+		_exit(0);
+	}
+
+	_exit(111);
+}
+
+char *
+auth_aliasempty(void)
+{
+	return (char *)0;
+}
+
+stralloc	loginstr = {0};
+stralloc	authdatastr = {0};
+
+ctrlfunc	ctrls[] = {
+		qldap_ctrl_trylogin,
+		qldap_ctrl_generic,
+		0 };
+
+int
+main(int argc, char **argv)
+{
+	struct	credentials c;
+	int r;
+
+	log_init(STDERR, ~256, 0);	/* XXX limited so that it is not
+					   possible to get passwords via 
+					   debug on production systems.
+					 */
+	if (read_controls(ctrls) == -1)
+		auth_error(AUTH_CONF);
+
+	auth_init(argc, argv, &loginstr, &authdatastr);
+	logit(256, "auth_init: login=%s, authdata=%s\n",
+	    loginstr.s, authdatastr.s);
+
+	if (authdatastr.len <= 1) {
+		logit(1, "alert: null password.\n");
+		auth_fail(loginstr.s, BADPASS);
+	}
+	
+	byte_zero(&c, sizeof(c));
+	r = check(cfuncs, &loginstr, &authdatastr, &c, 1);
+	/* XXX I'm not very happy with this solution but currently this
+	 * is the easiest way. This file, auth_mod.c and checkpassword.c
+	 * need some refactoring (: */
+	switch (r) {
+	case OK:
+	case FORWARD:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		auth_success(loginstr.s);
+	case NOSUCH: /* FALLTHROUGH */
+	case BADPASS:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		auth_fail(loginstr.s, r);
+	default:
+		/* authdata no longer needed */
+		byte_zero(authdatastr.s, authdatastr.len);
+		/* system error, now way out ... */
+		auth_error(r);
+	}
+		
+	auth_error(PANIC);
+	return 1; /* should never get here */
+}
+
+
diff -ruN qmail-1.03-orig/auto-gid.c qmail-1.03-ldap-20060201-orig/auto-gid.c
--- qmail-1.03-orig/auto-gid.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto-gid.c	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
 #include "fmt.h"
 
 char buf1[256];
-substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
+substdio ss1 = SUBSTDIO_FDBUF(subwrite,1,buf1,sizeof(buf1));
 
 void outs(s)
 char *s;
@@ -16,7 +16,7 @@
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -47,5 +47,5 @@
   outs(strnum);
   outs(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/auto-int8.c qmail-1.03-ldap-20060201-orig/auto-int8.c
--- qmail-1.03-orig/auto-int8.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto-int8.c	2006-02-25 11:00:55.000000000 +0100
@@ -5,15 +5,15 @@
 #include "fmt.h"
 
 char buf1[256];
-substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
+substdio ss1 = SUBSTDIO_FDBUF(subwrite,1,buf1,sizeof(buf1));
 
-void puts(s)
+void putstr(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -30,11 +30,11 @@
   scan_8long(value,&num);
   strnum[fmt_ulong(strnum,num)] = 0;
 
-  puts("int ");
-  puts(name);
-  puts(" = ");
-  puts(strnum);
-  puts(";\n");
+  putstr("int ");
+  putstr(name);
+  putstr(" = ");
+  putstr(strnum);
+  putstr(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/auto-int.c qmail-1.03-ldap-20060201-orig/auto-int.c
--- qmail-1.03-orig/auto-int.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto-int.c	2006-02-25 11:00:55.000000000 +0100
@@ -5,15 +5,15 @@
 #include "fmt.h"
 
 char buf1[256];
-substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
+substdio ss1 = SUBSTDIO_FDBUF(subwrite,1,buf1,sizeof(buf1));
 
-void puts(s)
+void putstr(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -30,11 +30,11 @@
   scan_ulong(value,&num);
   strnum[fmt_ulong(strnum,num)] = 0;
 
-  puts("int ");
-  puts(name);
-  puts(" = ");
-  puts(strnum);
-  puts(";\n");
+  putstr("unsigned int ");
+  putstr(name);
+  putstr(" = ");
+  putstr(strnum);
+  putstr(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/auto_patrn.h qmail-1.03-ldap-20060201-orig/auto_patrn.h
--- qmail-1.03-orig/auto_patrn.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto_patrn.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef AUTO_PATRN_H
 #define AUTO_PATRN_H
 
-extern int auto_patrn;
+extern unsigned int auto_patrn;
 
 #endif
diff -ruN qmail-1.03-orig/auto_spawn.h qmail-1.03-ldap-20060201-orig/auto_spawn.h
--- qmail-1.03-orig/auto_spawn.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto_spawn.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef AUTO_SPAWN_H
 #define AUTO_SPAWN_H
 
-extern int auto_spawn;
+extern unsigned int auto_spawn;
 
 #endif
diff -ruN qmail-1.03-orig/auto_split.h qmail-1.03-ldap-20060201-orig/auto_split.h
--- qmail-1.03-orig/auto_split.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto_split.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef AUTO_SPLIT_H
 #define AUTO_SPLIT_H
 
-extern int auto_split;
+extern unsigned int auto_split;
 
 #endif
diff -ruN qmail-1.03-orig/auto-str.c qmail-1.03-ldap-20060201-orig/auto-str.c
--- qmail-1.03-orig/auto-str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto-str.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,17 +1,17 @@
-#include "substdio.h"
 #include "readwrite.h"
+#include "substdio.h"
 #include "exit.h"
 
 char buf1[256];
-substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
+substdio ss1 = SUBSTDIO_FDBUF(subwrite,1,buf1,sizeof(buf1));
 
-void puts(s)
+void putstr(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -25,20 +25,20 @@
   value = argv[2];
   if (!value) _exit(100);
 
-  puts("char ");
-  puts(name);
-  puts("[] = \"\\\n");
+  putstr("char ");
+  putstr(name);
+  putstr("[] = \"\\\n");
 
-  while (ch = *value++) {
-    puts("\\");
+  while ((ch = *value++)) {
+    putstr("\\");
     octal[3] = 0;
     octal[2] = '0' + (ch & 7); ch >>= 3;
     octal[1] = '0' + (ch & 7); ch >>= 3;
     octal[0] = '0' + (ch & 7);
-    puts(octal);
+    putstr(octal);
   }
 
-  puts("\\\n\";\n");
+  putstr("\\\n\";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/auto-uid.c qmail-1.03-ldap-20060201-orig/auto-uid.c
--- qmail-1.03-orig/auto-uid.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto-uid.c	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
 #include "fmt.h"
 
 char buf1[256];
-substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
+substdio ss1 = SUBSTDIO_FDBUF(subwrite,1,buf1,sizeof(buf1));
 
 void outs(s) /* was named puts, but Solaris pwd.h includes stdio.h. dorks. */
 char *s;
@@ -16,7 +16,7 @@
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -41,11 +41,11 @@
 
   strnum[fmt_ulong(strnum,(unsigned long) pw->pw_uid)] = 0;
 
-  outs("int ");
+  outs("unsigned int ");
   outs(name);
   outs(" = ");
   outs(strnum);
   outs(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/auto_uids.h qmail-1.03-ldap-20060201-orig/auto_uids.h
--- qmail-1.03-orig/auto_uids.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/auto_uids.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,16 +1,16 @@
 #ifndef AUTO_UIDS_H
 #define AUTO_UIDS_H
 
-extern int auto_uida;
-extern int auto_uidd;
-extern int auto_uidl;
-extern int auto_uido;
-extern int auto_uidp;
-extern int auto_uidq;
-extern int auto_uidr;
-extern int auto_uids;
+extern unsigned int auto_uida;
+extern unsigned int auto_uidd;
+extern unsigned int auto_uidl;
+extern unsigned int auto_uido;
+extern unsigned int auto_uidp;
+extern unsigned int auto_uidq;
+extern unsigned int auto_uidr;
+extern unsigned int auto_uids;
 
-extern int auto_gidn;
-extern int auto_gidq;
+extern unsigned int auto_gidn;
+extern unsigned int auto_gidq;
 
 #endif
diff -ruN qmail-1.03-orig/auto_userl.h qmail-1.03-ldap-20060201-orig/auto_userl.h
--- qmail-1.03-orig/auto_userl.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/auto_userl.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,6 @@
+#ifndef AUTO_USERL_H
+#define AUTO_USERL_H
+
+extern char auto_userl[];
+
+#endif
